=== debian/changelog ===
dino-im (0.4.3-3) unstable; urgency=medium

  * Add upstream commit to fix implicit-function-declaration (Closes: #1066528)

 -- Martin <debacle@debian.org>  Wed, 13 Mar 2024 17:48:38 +0000

dino-im (0.4.3-2) unstable; urgency=medium

  [ John Scott ]
  * Switch the Homepage to dino.im

 -- Martin <debacle@debian.org>  Tue, 11 Jul 2023 20:14:59 +0000

dino-im (0.4.3-1) unstable; urgency=medium

  * Maintenance release with bug fixes.

 -- Martin <debacle@debian.org>  Tue, 11 Jul 2023 18:26:18 +0000
