=== debian/changelog ===
dino-im (0.4.4-1ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jan 2025 05:30:09 +0100

dino-im (0.4.4-1ubuntu1) plucky; urgency=medium

  * d/control: replace libwebrtc-audio-processing-dev with new package name
    libwebrtc-audio-processing-1-dev.

 -- Mateus Rodrigues de Morais <mateus.morais@canonical.com>  Thu, 19 Dec 2024 13:03:41 -0300

dino-im (0.4.4-1) unstable; urgency=medium

  * Maintenance release with bug fixes.
  * Drop obsolete upstream patches.

 -- Martin <debacle@debian.org>  Thu, 04 Jul 2024 21:28:33 +0000

dino-im (0.4.3-4) unstable; urgency=medium

  * Add patch to fix compatibility with valac 0.56.17 (Closes: #1070457)

 -- Martin <debacle@debian.org>  Sun, 05 May 2024 19:48:57 +0000
