=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: dino-im
-Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
 Uploaders: Martin <debacle@debian.org>,
            Taowa <taowa@debian.org>
 Section: net
@@ -25,7 +26,7 @@
 	libsoup-3.0-dev,
 	libsqlite3-dev,
 	libsrtp2-dev,
-	libwebrtc-audio-processing-dev,
+	libwebrtc-audio-processing-1-dev,
 	ninja-build,
 	valac,
 Standards-Version: 4.1.4
