## dino-im 0.4.5

=== plugins/rtp/CMakeLists.txt ===
--- 
+++ 
@@ -53,16 +53,25 @@
     set(RTP_DEFINITIONS ${RTP_DEFINITIONS} ENABLE_MSDK)
 endif()
 
-if(WebRTCAudioProcessing_VERSION GREATER "0.4")
-    message(STATUS "Ignoring WebRTCAudioProcessing, only versions < 0.4 supported so far")
+if(WebRTCAudioProcessing_VERSION GREATER_EQUAL "3.0")
+    message(STATUS "Ignoring WebRTCAudioProcessing, only versions 0.2+, 1.* and 2.* supported so far")
     unset(WebRTCAudioProcessing_FOUND)
 endif()
 
 if(WebRTCAudioProcessing_FOUND)
     set(RTP_DEFINITIONS ${RTP_DEFINITIONS} WITH_VOICE_PROCESSOR)
+    if(WebRTCAudioProcessing_VERSION GREATER_EQUAL "2.0")
+        set(RTP_VOICE_PROCESSOR_CFLAGS "-DWEBRTC2")
+        set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing-2)
+    elseif(WebRTCAudioProcessing_VERSION GREATER_EQUAL "1.0")
+        set(RTP_VOICE_PROCESSOR_CFLAGS "-DWEBRTC1")
+        set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing-1)
+    else()
+        set(RTP_VOICE_PROCESSOR_CFLAGS "-DWEBRTC0")
+        set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing)
+    endif()
     set(RTP_VOICE_PROCESSOR_VALA src/voice_processor.vala)
     set(RTP_VOICE_PROCESSOR_CXX src/voice_processor_native.cpp)
-    set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing)
 else()
     message(STATUS "WebRTCAudioProcessing not found, build without voice pre-processing!")
 endif()
@@ -90,7 +99,7 @@
     ${RTP_EXTRA_OPTIONS}
 )
 
-add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="rtp" -I${CMAKE_CURRENT_SOURCE_DIR}/src)
+add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="rtp" -I${CMAKE_CURRENT_SOURCE_DIR}/src ${RTP_VOICE_PROCESSOR_CFLAGS})
 add_library(rtp SHARED ${RTP_VALA_C} ${RTP_VOICE_PROCESSOR_CXX} src/gst_fixes.c)
 target_link_libraries(rtp libdino crypto-vala ${RTP_PACKAGES} gstreamer-rtp-1.0 ${RTP_VOICE_PROCESSOR_LIB})
 set_target_properties(rtp PROPERTIES PREFIX "")
