=== debian/changelog ===
dino-im (0.4.5-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Martin <debacle@debian.org>  Sun, 02 Mar 2025 08:53:53 +0000

dino-im (0.4.5-1) unstable; urgency=medium

  * Maintenance release with bug fixes.

 -- Martin <debacle@debian.org>  Mon, 24 Feb 2025 21:52:00 +0000
